﻿Clear-Host;

##############################

# RUN THIS SCRIPT WITH POWERSHELL 7

##############################


# Reference: https://learn.microsoft.com/en-us/powershell/scripting/install/installing-powershell-on-windows?view=powershell-7.3#installing-the-msi-package

# Download: https://github.com/PowerShell/PowerShell/releases/download/v7.3.8/PowerShell-7.3.8-win-x64.msi

Install-Module -Name "PnP.PowerShell" -AllowClobber;

###Enter your values below###

$appId = "8345ce8e-735a-4d82-9669-b30f7df5ccd1"; # Application Client ID

$_sites = 'https://M365x65968740.sharepoint.com/sites/AppCatalog', 'https://M365x65968740.sharepoint.com/sites/Main', 'https://M365x65968740.sharepoint.com/sites/Site3';

foreach ($siteUrl in $_sites) {

    Write-Host "Updating permissions on $siteUrl";

    #Connect using Sites.FullControl.All as a user or app

    Connect-PnPOnline -Url $siteUrl -Interactive;

    #First create a Read or Write permission entry for the app to the site. Currently unable to Set as FullControl
    $grant = Grant-PnPAzureADAppSitePermission -Permissions "Write" -Site $siteUrl -AppId $appId -DisplayName "SitesResourceSpecific";

    #Get the Permission ID for the app using App Id
    $PermissionId = Get-PnPAzureADAppSitePermission -AppIdentity $appId;

    #Change the newly created Read/Write app site permission entry to FullControl
    Set-PnPAzureADAppSitePermission -Site $siteUrl -PermissionId $(($PermissionId).Id) -Permissions "FullControl";
}